import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { lazy, Suspense } from 'react';
const DefaultFallback = () => null;
/* eslint-disable-next-line @typescript-eslint/no-explicit-any */
export function loadable(loadFunction, Fallback, 
// eslint-disable-next-line @typescript-eslint/no-explicit-any
ExtraComponent) {
    const LazyComponent = lazy(async () => ({
        default: await loadFunction(),
    }));
    const UsageFallback = Fallback ?? DefaultFallback;
    return (props) => (_jsxs(Suspense, { fallback: _jsx(UsageFallback, { ...props }), children: [_jsx(LazyComponent, { ...props }), ExtraComponent && _jsx(ExtraComponent, {})] }));
}
